#!/usr/local/shpot/thpfunc.pl 


# Copyright George Bakos - alpinista@bigfoot.com
# July 15, 2002
# This is free software, released under the terms of the GNU General 
# Public License avaiable at http://www.fsf.org/licenses/gpl.txt


sub getip {
$reply = `/sbin/ifconfig $intf`;
if ($reply =~ /^.*?\b(\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3})\b.*/is) {
  $thpaddr = $1
}
}

sub gettime {
if (eval "require 'sys/syscall.ph'") {
  my $now = pack("LL", ());
  syscall( &SYS_gettimeofday, $now, undef) >= 0
        or die "gettimeofday: $!";
  my($secs, $usecs) = unpack("LL", $now);
  $timestp = sprintf ("%.X%.X", ("$secs", "$usecs"));
  $shorttime = $secs;
} else {
$shorttime = $timestp = time();
}
}

# signal handlers

# Use a SIGALRM to limit time of execution of each script
# Since $sid is only used to label the caplog entry (once
# things get going) we can here add a comment to it and exit
# with a nonzero value.
# It's a bit of a kludge; please improve on this, folks.

sub closeout {
  $sid = "$sid - timeout";
  clcaplog();
  close(CAPLOG);
  exit 5;
}
$SIG{ALRM} = \&closeout;

# Here, we manage the caplog file, which tracks all sessions

sub opncaplog {
  gettime();
 $start = $shorttime;
  $sid = $timestp;

  if ($svcname) {
        $sid="$sid.$svcname"}

  $sesslog="$logdir/$sid";

  open(CAPLOG, ">>$logfile");
  print (CAPLOG "\n", strftime("%b %d %T", localtime(time)), " start thp SID $sid, UNIX pid $procid\n");
}

sub clcaplog { 
  gettime();
  $end = $shorttime;
  $eltime = $end - $start;

  print CAPLOG strftime("%b %d %T", localtime(time)), " end thp SID $sid\n";

  if ($eltime > 0) {
      print CAPLOG "\t- elapsed time ", strftime("%T", gmtime($eltime)), "\n";
  }

  if ($size=(-s $sesslog)) {
      print CAPLOG "\t- total $size bytes\n";
  }
}


sub catchall {
  $ENV{'PATH'} = '/bin:/usr/bin';
  delete @ENV{'IFS', 'CDPATH', 'ENV', 'BASH_ENV'};

  open(GREETING, "$greetbin|");
  while(<GREETING>) {
    print STDERR $_;
  }
  close(GREETING);

  print STDERR "$prompt";

  while (<STDIN>) {
    open(LOG, ">>$sesslog");
    print STDERR "$prompt";
    print LOG $_;
    close(LOG);
    if (/exit|logout|quit/) {
        return;
    }
  }
}
sub shell {
  $ENV{'PATH'} = '/bin:/usr/bin';
  delete @ENV{'IFS', 'CDPATH', 'ENV', 'BASH_ENV'};

  open(GREETING, "$greetbin|");
  while(<GREETING>) {
    print STDERR $_;
  }
  close(GREETING);

  print STDERR "$prompt";

  while (my $commands = <STDIN>) {
      chomp $commands;
      $commands =~ s/\r//;
      @commands=split /\s+/,($commands);
      open(LOG, ">>$sesslog");
     if( ! ($commands[0] =~ /exit|logout|quit/) ) {
         print STDERR "$prompt";
     }
      if ($commands[0] =~ /ls/){
          open (LS,"</usr/local/shpot/ls.txt");
          while (<LS>){
              print STDERR  $_;
          }
          close(LS);
      }
      
      print LOG $_;
      close(LOG);
      
      if ($commands[0] =~ /exit|logout|quit/) {
          return;
      }
  }
}


sub ftp {
my $ftpuser = anon;
my $type = I;
my @addroct = split /\./, $thpaddr;
my @portoct = ((($shorttime % 124) + 4),($shorttime % 255));
my $file = "file";
%ftphash = (
        user    =>      "331 Password required for $ftpuser\x0d\x0a",
        pass    =>      "230 User $ftpuser logged in.\x0d\x0a",
        already =>      "530 Already logged in.\x0d\x0a",
        nologin =>      "530 Please login with USER and PASS.\x0d\x0a",
        start   =>      "220 $hostname.$domain $ftpver ready.\x0d\x0a",
        syst    =>      "215 UNIX Type: L8\x0d\x0a",
        pwd     =>      "257 \"/\" is current directory.\x0d\x0a",
        type    =>      "200 Type set to $type.\x0d\x0a",
        mkd     =>      "257 New directory created.\x0d\x0a",
        stor    =>      "150 Opening BINARY mode data connection.\x0d\x0a",
        pwd     =>      "257 \"/\" is current directory.\x0d\x0a",
        cwd     =>      "250 CWD command successful.\x0d\x0a",
        cdup    =>      "257 \"/\" is current directory.\x0d\x0a",
        port    =>      "500 Passive mode only.\x0d\x0a",
        compl   =>      "226 Transfer complete.\x0d\x0a",
        rnfr    =>      "350 File exists, ready for destination name.\x0d\x0a",
        rnto    =>      "250 RNTO command successful.\x0d\x0a",
        retr    =>      qq (150 Opening ASCII mode data connection for \'$file\'.\x0d\x0a),
        list    =>      qq (150 Opening ASCII mode data connection for 'file list'.\x0d\x0a),
        pasv    =>      qq (227 Entering Passive Mode \(@addroct[0],@addroct[1],@addroct[2],@addroct[3],@portoct[0],@portoct[1]\)\x0d\x0a),
        #pasv   =>      qq (227 Entering Passive Mode \x0d\x0a),
        help    =>      qq (214-The following commands are recognized.
   USER    PORT    STOR    RNTO    NLST    MKD     CDUP 
   PASS    PASV    APPE    ABOR    SITE    XMKD    XCUP 
   TYPE    DELE    SYST    RMD     STOU 
   STRU    ALLO    CWD     STAT    XRMD    SIZE 
   MODE    REST    XCWD    HELP    PWD     MDTM 
   QUIT    RETR    RNFR    LIST    NOOP    XPWD 
214 Direct comments to root\@localhost.\x0d\x0a),

        "site help" =>  qq (214-The following SITE commands are recognized.
   UMASK   CHMOD   GROUP   NEWER   INDEX   ALIAS   GROUPS 
   IDLE    HELP    GPASS   MINFO   EXEC    CDPATH 
214 Direct comments to root\@localhost.\x0d\x0a),

        quit    =>      qq (221-You have transferred 0 bytes in 0 files.
221-Total traffic for this session was 2164 bytes in 0 transfers.
221 Thank you for using the FTP service on $hostname.$domain.\x0d\x0a)
);
        
  $login = 0;
  print STDERR $ftphash{start};
  while (my $commands = <STDIN>) {
    open(LOG, ">>$sesslog");
    print LOG $commands;
    chomp $commands;
    $commands =~ s/\r//;
    @commands=split /\s+/,($commands);

    if ($commands[0] =~ /user/i && $commands[1] =~ /[[:alnum:]]+/){
        if ($login == 1) {
          print STDERR $ftphash{already};
        } else {
          $ftpuser = $commands[1];
          $ftphash{user} =~ s/anon/$ftpuser/;
          $ftphash{pass} =~ s/anon/$ftpuser/;
          print STDERR $ftphash{user};
        }

    } elsif ($commands[0] =~ /pass/i && $commands[1] =~ /[[:print:]]+/) {
        if ($login == 1) {
          print STDERR $ftphash{already};
        } else { 
          if ($ftpuser) {
            $login = 1;
            print STDERR $ftphash{pass};
          }
        }

    } elsif ($commands[0] =~ /list|retr|stor/i) {
        if ($login == 1) {
          $commands[0] =~ tr/A-Z/a-z/;
          print STDERR $ftphash{$commands[0]};
          sleep 1;
          print STDERR $ftphash{compl};
        } else {
          print STDERR $ftphash{nologin};
        }

   } elsif ($commands[0] =~ /help|pasv|port|pwd|syst|rnfr|rnto|mkd|cwd|cdup|type/i) {
        if ($login == 1) {
          $commands[0] =~ tr/A-Z/a-z/;
          print STDERR $ftphash{$commands[0]};
        } else {
          print STDERR $ftphash{nologin};
        }

    } elsif ("$commands" =~ /\bsite help\b/i) {
        if ($login == 1) {
          $commands =~ tr/A-Z/a-z/;
          print STDERR $ftphash{"$commands"};
        } else {
          print STDERR $ftphash{nologin};
        }

   } elsif ($commands[0] =~ /exit\b|quit\b/i) {
        print STDERR $ftphash{quit};
        return;

    } else {
        if ($login == 1) {
          print STDERR "500 @commands: command not understood.\x0d\x0a";
        } else {
        print STDERR $ftphash{nologin};
        }
    }
    close LOG;
}
}

sub nullresp {
  while (<STDIN>) {
    open(LOG, ">>$sesslog");
    print LOG $_;
    close LOG;
  }
}

sub http {
$respdir = "$thpdir/resp/httpd/$httpver";

  while (my $commands = <STDIN>) {
    open(LOG, ">>$sesslog");
    print LOG $commands;
    chomp $commands;
    $commands =~ s/\r//;
    @commands=split /\s+/,($commands);

    if ($commands[0] =~ /get|post|head/i && $commands[1] =~ /[[:graph:]]+/){
        open (RESP, "$respdir/200");
        while (<RESP>) {
          chomp;
          print STDERR ($_, "\x0d\x0a");
          }
        close RESP;
        }
    close LOG;
    return;
  }
}

sub pop3 {
%pop3hash = (
        dele     => "-ERR Incorrect command sequence\x0d\x0a",
        list     => "-ERR Incorrect command sequence\x0d\x0a",
        noop     => "-ERR Incorrect command sequence\x0d\x0a",
        pass     => "-ERR Unknown user or incorrect password\x0d\x0a",
        quit     => "+OK $hostname.$domain closing connection\x0d\x0a",
        retr     => "-ERR Incorrect command sequence\x0d\x0a",
        rset     => "-ERR Incorrect command sequence\x0d\x0a",
        stat     => "-ERR Incorrect command sequence\x0d\x0a",
        top      => "-ERR Incorrect command sequence\x0d\x0a",
        user     => "OK $commands[1] \x0d\x0a",
        usernull => "-ERR Parameters required\x0d\x0a"
        );
        my $DATE = `date`;
        chomp $DATE;
        print  STDERR "+OK $hostname.$domain $pop3ver, $DATE -0500 <20020904175615@$hostname.domain>\x0d\x0a\r";
        while (my $commands = <STDIN>) {
            open(LOG, ">>$sesslog");
            print LOG $commands;
            chomp $commands;
            $commands =~ s/\r//;
            @commands=split /\s+/,($commands);
            if ($commands[0] =~ /dele|list|noop|retr|rset|stat|top/i) {
                print STDERR $pop3hash{$commands[0]};
                sleep 5;
            }
            elsif($commands[0] =~ /quit/i) {
            print STDERR $pop3hash{quit};
            return;
            }
            elsif($commands[0] =~ /pass/i) {
                 sleep 3;
                 print STDERR $pop3hash{pass};
            }
            elsif($commands[0] =~ /user/i) {
              if($commands[1] eq ''){
                 print STDERR $pop3hash{usernull};
              }
              else{
              print STDERR "OK $commands[1] \x0d\x0a";
#             print STDERR $pop3hash{user};
              }
            }
            else {
            print STDERR "-ERR Command unrecognized: \"$commands\" \x0d\x0a";
            }
        }
        close LOG;
}


sub ssh {
    my $textfin = '';
    $textfin = "Protocol mismatch.\n";
    
    open(LOG, ">>$sesslog");
    print LOG $commands;
    chomp $commands;
    $commands =~ s/\r//;
    @commands=split /\s+/,($commands);
    print STDERR "$sshver\n\n";
    print STDERR "$textfin";
    close LOG;
}

sub smtp {
    $saidhelo = 0;
    $saidmail = 0;
    $datamode = 0;
    my $DATE = `date`;

    print  STDERR "220 $hostname.$domain $smtpver $DATE\r";
    while (my $commands = <STDIN>) {
        open(LOG, ">>$sesslog");
        print LOG $commands;
        chomp $commands;
        $commands =~ s/\r//;
        @commands=split /\s+/,($commands);

%smtphash = (
                 auth => "503 AUTH mechanism not available.\x0d\x0a",
                 badrcpt => "503 5.0.0 Need MAIL before RCPT\x0d\x0a",
                 badhelo => "503 5.0.0 Polite people say HELO first\x0d\x0a",
                 data => "354 Enter mail, end with \"\.\" on a line by itself\x0d\x0a",
                 dataerr => "503 5.0.0 Need MAIL command\x0d\x0a",
                 datasent => "250 2.0.0 g8684xUD014698 Message accepted for delivery\x0d\x0a",
                 ehloout => "501 5.0.0 helo requires domain address.\x0d\x0a",
                 err => "500 5.5.1 Command unrecognized: $commands\x0d\x0a",
                 etrn => "500 5.5.2 Parameter required\x0d\x0a",
                 expn => "502 5.7.0 Sorry, we do not allow this operation.\x0d\x0a",
                 heloerr => "501 5.0.0 Invalid domain name\x0d\x0a",
                 heloout => "501 5.0.0 helo requires domain address.\x0d\x0a",
                 heloin => "250 $hostname.$domain Hello $commands[1], pleased to meet you.\x0d\x0a",
                 mailfrom => "553 5.5.4 $commands[1]... Domain name required for sender address $commands[1]\x0d\x0a",
                 mailto => "250 2.1.0 $maildata... Sender ok\x0d\x0a",
                 mail => "501 5.5.2 Syntax error in parameters scanning \"$commands[1]\"\x0d\x0a",
                 noop => "250 2.0.0 OK.\x0d\x0a",
                 quit => "220 2.0.0 $hostname.$domain closing connection..\x0d\x0a",
                 rcptto => "250 2.1.5 $commands[2]... Recipient ok\x0d\x0a",
                 reset => "250 2.0.0 Reset state.\x0d\x0a",
                 rset => "250 2.0.0 Reset state\x0d\x0a",
                 starttls => "454 4.3.3 TLS not available after start..\x0d\x0a",
                 vrfy => "252 2.5.2 Cannot VRFY user; try RCPT to attempt delivery (or try finger).\x0d\x0a",
                 help => qq(214-2.0.0 $smtpver
214-2.0.0 Topics:
214-2.0.0       HELO    EHLO    MAIL    RCPT    DATA
214-2.0.0       RSET    NOOP    QUIT    HELP    VRFY
214-2.0.0       EXPN    VERB    ETRN    DSN     AUTH
214-2.0.0       STARTTLS
214-2.0.0 For more info use \"HELP <topic>\".
214-2.0.0 For local information send email to Postmaster at your site.
214 2.0.0 End of HELP info.\x0d\x0a),
                 ehlo => "250-ENHANCEDSTATUSCODES
250-8BITMIME
250-SIZE
250-DSN
250-ONEX
250-ETRN
250-XUSR
250 HELP.)\x0d\x0a",
                 );

        if ($commands[0] =~ /helo/i){
            if($commands[1] eq ''){
                print STDERR $smtphash{heloout};
               }elsif($commands[1] =~ /[\!\@\#\$\%\^&\*\(\)\|\\,>?\/\"\':;\{\}]/) {
               print STDERR $smtphash{heloerr};
               }else{
                   print STDERR $smtphash{heloin};
                  $saidhelo = 1;
               }
        }
        elsif ($commands[0] =~ /help|reset|noop|auth|starttls|vrfy|expn|etrn|rset/i) {
            $commands[0] =~ tr/A-Z/a-z/;
            print STDERR $smtphash{$commands[0]};
            sleep 1;
        }
        elsif($commands[0] =~ /ehlo/i){
            if($commands[1] eq ''){
                print STDERR $smtphash{ehloout};
            }else{
                print STDERR $smtphash{heloin};
                print STDERR $smtphash{ehlo};
                $saidhelo = 1;
            }
        }
        elsif($commands[0] =~ /exit\b|quit\b/i) {
            print STDERR $smtphash{quit};
            return;
        }
        elsif($commands[0] =~ /mail/i) {
            $maildata = $commands[2];
            if($commands[2] eq '') {
               $maildata = $commands[1];
                 if ($commands[1] =~ m@.*from:<(.*)>@i) {
                 $maildata = $1;
                 }
            }
            if($saidhelo == 0) {
              print STDERR $smtphash{badhelo};
             }elsif($commands[1] =~ /from:/i) {
                 if($commands[2] =~ /\@/ || $commands[1]=~ /\@/) {
                    $saidmail = 1;
                    print STDERR "250 2.1.0 $maildata... Sender ok\x0d\x0a";
                 }else{ 
                    print STDERR "553 5.5.4 $maildata... Domain name required for sender address $maildata\x0d\x0a";
                 }
             }elsif($saidhelo == 1) {
                    print STDERR $smtphash{mail};
            }
        }
        elsif($commands[0] =~ /rcpt/i) {
            $maildata = $commands[2];
            if ($commands[1] =~ m@.*to:<(.*)>@i || $commands[2] =~ m@<(.*)>@ ) {
               $maildata = $1;
            }
          if($saidmail == 0) {
               print STDERR $smtphash{badrcpt};
               }else{
                    if($commands[1] =~ /to:/i && $maildata ne '' ) {
                    print STDERR  "250 2.1.5 $maildata... Recipient ok\x0d\x0a";
                    }else{
                    print STDERR $smtphash{mail};
                    }
          }
        }
        elsif($commands[0] =~ /data/i) {
             if($saidmail == 1) {
                print STDERR $smtphash{data};
                while (<STDIN>) {
                last if /^\.\x0d$/;
                }
                print STDERR $smtphash{datasent};
             }else{
                print STDERR $smtphash{dataerr};
             }
        }
        else {
        print STDERR $smtphash{err};
        }
        close LOG;
    }
}
